
//=========================================================================
//Copyright LizardOfOz.
//This is still beta and things might and will change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy - Saxton Hale's model imitating Jungle Inferno SFM; Custom animations and promotional material.
//  Velly - VFX, animations scripting, technical assistance
//  JPRAS - Mayann Hale body reference, model feedback.
//  MegapiemanPHD - Saxton Hale and Gray Mann voice acting.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

PrecacheScriptSound("saxton_hale.kill_scout")
PrecacheScriptSound("saxton_hale.kill_soldier")
PrecacheScriptSound("saxton_hale.kill_pyro")
PrecacheScriptSound("saxton_hale.kill_demoman")
PrecacheScriptSound("saxton_hale.kill_heavy")
PrecacheScriptSound("saxton_hale.kill_engineer")
PrecacheScriptSound("saxton_hale.kill_medic")
PrecacheScriptSound("saxton_hale.kill_sniper")
PrecacheScriptSound("saxton_hale.kill_spy")
PrecacheScriptSound("saxton_hale.kill_generic")
PrecacheScriptSound("saxton_hale.kill_medic_last")
PrecacheScriptSound("saxton_hale.kill_medic_only")
PrecacheScriptSound("saxton_hale.kill_special")

PrecacheScriptSound("saxton_hale.welcome")
PrecacheScriptSound("saxton_hale.bailout")
PrecacheScriptSound("saxton_hale.round_start")
PrecacheScriptSound("saxton_hale.round_start_long")
PrecacheScriptSound("saxton_hale.round_start_beer")
PrecacheScriptSound("saxton_hale.round_start_mercs_lost")
PrecacheScriptSound("saxton_hale.hale_win")
PrecacheScriptSound("saxton_hale.mercs_win")
PrecacheScriptSound("saxton_hale.point_enabled")

PrecacheScriptSound("saxton_hale.setup_1sec")
PrecacheScriptSound("saxton_hale.setup_2sec")
PrecacheScriptSound("saxton_hale.setup_3sec")
PrecacheScriptSound("saxton_hale.setup_4sec")
PrecacheScriptSound("saxton_hale.setup_5sec")
PrecacheScriptSound("saxton_hale.setup_10sec")

PrecacheScriptSound("saxton_hale.call_medic")
PrecacheScriptSound("saxton_hale.call_spy")
PrecacheScriptSound("saxton_hale.last_mann_hiding")
PrecacheScriptSound("saxton_hale.jarated")
PrecacheScriptSound("saxton_hale.laugh")
PrecacheScriptSound("saxton_hale.pain")
PrecacheScriptSound("saxton_hale.pain_big")

PrecacheScriptSound("saxton_hale.saxton_punch_ready")
PrecacheScriptSound("saxton_hale.saxton_punch")

PrecacheScriptSound("saxton_hale.jump")
PrecacheScriptSound("saxton_hale.rage")

PrecacheScriptSound("saxton_hale.charge_a")
PrecacheScriptSound("saxton_hale.charge_b")
PrecacheScriptSound("saxton_hale.charge_c")
PrecacheScriptSound("saxton_hale.dash_a")
PrecacheScriptSound("saxton_hale.dash_b")
PrecacheScriptSound("saxton_hale.dash_c")

PrecacheScriptSound("saxton_hale.saxton_hale_gaming")

::GetCurrentCharacterName <- function(player)
{
    if (IsHale(player))
        return "saxton_hale";
    local className = TF_CLASS_NAMES[player.GetPlayerClass()];
    if (className != null)
        return className;
    return "generic";
}

function SoundDirector_OnDeath(params)
{
    if (params.crit_type > 0 || params.damagebits == 1 || params.damagebits == 2 || GetAliveMercCount() == 1)
        return;
    local victim;
    if ((victim = GetPlayerFromParams(params)) == null)
        return;
    local attacker;
    if ((attacker = GetPlayerFromParams(params, "attacker")) == null || IsNotHale(attacker))
        return;

    local voiceLine = null;
    if (victim.GetPlayerClass() == TF_CLASS.MEDIC && !IsAnyMedicAlive())
        voiceLine = GetMedicPlayerCount() > 1 ? "kill_medic_last" : "kill_medic_only";
    else if (RandomInt(1, 3) == 1)
        voiceLine = RandomInt(0,1) == 0 ? "kill_generic" : "kill_"+GetCurrentCharacterName(victim);

    if (voiceLine != null)
        PlayAnnouncerVO(GetCurrentCharacterName(attacker), voiceLine);
}
AddListener("death", SoundDirector_OnDeath, 10);

function IsAnyMedicAlive()
{
    local count = 0;
    for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++)
    {
        local player = PlayerInstanceFromIndex(i);
        if (IsMercAlive(player) && player.GetPlayerClass() == TF_CLASS.MEDIC)
            if (count++ == 1)
                return true;
    }
    return false;
}

function GetMedicPlayerCount()
{
    local count = 0;
    for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++)
    {
        local player = PlayerInstanceFromIndex(i);
        if (IsValidPlayer(player) && player.GetPlayerClass() == TF_CLASS.MEDIC)
            count++;
    }
    return count;
}